﻿using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Export_Data_Database_HTML_File_Razor_Core.Models;
using System.Linq;
using System.Text;

namespace Export_Data_Database_HTML_File_Razor_Core.Pages
{
    public class IndexModel : PageModel
    {
        private DBCtx Context { get; }

        public IndexModel(DBCtx _context)
        {
            this.Context = _context;
        }

        public List<Customer> Customers { get; set; }

        public void OnGet()
        {
            this.Customers = this.Context.Customers.Take(10).ToList();
        }

        public FileResult OnPostExport()
        {
            List<object> customers = (from customer in this.Context.Customers.Take(10)
                                       select new[] {
                                            customer.CustomerID,
                                            customer.ContactName,
                                            customer.City,
                                            customer.Country
                                    }).ToList<object>();

            //Building an HTML string.
            StringBuilder sb = new StringBuilder();

            //Table start.
            sb.Append("<table border='1' cellpadding='5' cellspacing='0' style='border: 1px solid #ccc;'>");

            //Building the Header row.
            sb.Append("<tr>");
            sb.Append("<th style='background-color: #B8DBFD;border: 1px solid #ccc'>CustomerID</th>");
            sb.Append("<th style='background-color: #B8DBFD;border: 1px solid #ccc'>ContactName</th>");
            sb.Append("<th style='background-color: #B8DBFD;border: 1px solid #ccc'>City</th>");
            sb.Append("<th style='background-color: #B8DBFD;border: 1px solid #ccc'>Country</th>");
            sb.Append("</tr>");

            //Building the Data rows.
            for (int i = 0; i < customers.Count; i++)
            {
                string[] customer = (string[])customers[i];
                sb.Append("<tr>");
                for (int j = 0; j < customer.Length; j++)
                {
                    //Append data.
                    sb.Append("<td style='border: 1px solid #ccc'>");
                    sb.Append(customer[j]);
                    sb.Append("</td>");
                }
                sb.Append("</tr>");
            }

            //Table end.
            sb.Append("</table>");

            return File(Encoding.ASCII.GetBytes(sb.ToString()), "text/html", "Grid.htm");
        }
    }
}